local RT_GlobalStrings = {};
local ParseFunction;
local parseBuffer;
local parseOrder;
local parseCount;

ParseFunction = function (character)
	local result;
	if(not parseBuffer) then
		if(character == "%") then
			parseBuffer = character;
			result = "";
		else
			if(string.find(character, "[%^%$%(%)%%%.%[%]%*%+%-%?]")) then
				result = "%"..character;
			else
				result = character;
			end
		end
	else
		parseBuffer = parseBuffer..character;
		if(string.find(character, "[%%cEefgGiouXxqs]")) then
			local order;
			_, _, order = string.find(parseBuffer, "(%d+)%$");
			parseCount = parseCount + 1;
			if(order) then
				parseOrder[parseCount] = tonumber(order);
			else
				parseOrder[parseCount] = parseCount;
			end
			result = "(.+)";
			parseBuffer = nil;
		elseif(string.find(character, "[%%d]")) then
			local order;
			_, _, order = string.find(parseBuffer, "(%d+)%$");
			parseCount = parseCount + 1;
			if(order) then
				parseOrder[parseCount] = tonumber(order);
			else
				parseOrder[parseCount] = parseCount;
			end
			result = "(%d+)";
			parseBuffer = nil;
		elseif(string.find(character, "[%$%.%d]")) then
			result = "";
		else
			result = parseBuffer;
			parseBuffer = nil;
		end
	end
	return result;
end

function RTGlobalParser_Format(formatString)
	parseBuffer = nil;
	parseOrder = {};
	parseCount = 0;

	if (RT_GlobalStrings[formatString] == nil) then
		local parseString = string.gsub(formatString, ".", ParseFunction);
		RT_GlobalStrings[formatString] = { parseString, parseOrder };
	end	
	return RT_GlobalStrings[formatString];
end

function RTGlobalParser_ParseMessage(arg1, formatString)
	local parseResult;
	local findResult;
	
	parseResult = RTGlobalParser_Format(formatString);
	findResult = {string.find(arg1, parseResult[1])};
	if(findResult[1]) then
		local i, n;
		local callResult = {};
		n = table.getn(findResult);
		for i=3,n do
			callResult[parseResult[2][i-2]] = findResult[i];
		end
		return unpack(callResult);
	end
	return nil;
end